"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = subscribeToContext;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

var getDisplayName = function getDisplayName(comp) {
  return comp.displayName || comp.name || 'Component';
};

function subscribeToContext(Consumer) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$propName = _ref.propName,
      propName = _ref$propName === void 0 ? 'context' : _ref$propName;

  return function (Component) {
    function Subscriber(_ref2) {
      var innerRef = _ref2.innerRef,
          props = _objectWithoutProperties(_ref2, ["innerRef"]);

      return _react.default.createElement(Consumer, null, function (context) {
        var addProps = _defineProperty({}, propName, context);

        return _react.default.createElement(Component, _extends({
          ref: innerRef
        }, addProps, props));
      });
    }

    var displayName = "ContextSubscriber(".concat(getDisplayName(Component), ")");
    Subscriber.propTypes = {
      innerRef: _propTypes.default.func
    };
    Subscriber.defaultProps = {
      innerRef: null
    };
    Subscriber.displayName = displayName;

    function forwardRef(props, ref) {
      return _react.default.createElement(Subscriber, _extends({
        innerRef: ref
      }, props));
    }

    forwardRef.displayName = displayName;
    return _react.default.forwardRef ? _react.default.forwardRef(forwardRef) : Subscriber;
  };
}